diff --git a/src/library_pthread.js b/src/library_pthread.js
index 48af2944799..31e40061ee8 100644
--- a/src/library_pthread.js
+++ b/src/library_pthread.js
@@ -706,7 +706,9 @@ var LibraryPThread = {
     var detached = 0;
     var schedPolicy = 0; /*SCHED_OTHER*/
     var schedPrio = 0;
-    if (attr) {
+    // When musl creates C11 threads it passes __ATTRP_C11_THREAD (-1) which
+    // treat as if it was NULL.
+    if (attr && attr != {{{ cDefine('__ATTRP_C11_THREAD') }}}) {
       stackSize = {{{ makeGetValue('attr', 0, 'i32') }}};
       // Musl has a convention that the stack size that is stored to the pthread
       // attribute structure is always musl's #define DEFAULT_STACK_SIZE
@@ -961,6 +963,7 @@ var LibraryPThread = {
     return 0;
   },
 
+  pthread_detach__sig: 'vi',
   pthread_detach: function(thread) {
     if (!thread) {
       err('pthread_detach attempted on a null thread pointer!');
@@ -979,6 +982,10 @@ var LibraryPThread = {
     return wasDetached ? ERRNO_CODES.EINVAL : 0;
   },
 
+  // C11 threads function.
+  // TODO: remove this in favor or compiling musl/src/thread/pthread_detach.c
+  thrd_detach: 'pthread_detach',
+
   pthread_exit__deps: ['exit'],
   pthread_exit: function(status) {
     if (!ENVIRONMENT_IS_PTHREAD) _exit(status);
diff --git a/src/struct_info.json b/src/struct_info.json
index e5527f25c31..8a1c1a49f9f 100644
--- a/src/struct_info.json
+++ b/src/struct_info.json
@@ -1544,7 +1544,8 @@
               "cancelasync",
               "locale"
             ]
-        }
+        },
+        "defines": ["__ATTRP_C11_THREAD"]
     },
     {
         "file": "../lib/libc/musl/src/internal/libc.h",
diff --git a/system/lib/libc/musl/src/thread/thrd_create.c b/system/lib/libc/musl/src/thread/thrd_create.c
index e0336695265..891d227bcf9 100644
--- a/system/lib/libc/musl/src/thread/thrd_create.c
+++ b/system/lib/libc/musl/src/thread/thrd_create.c
@@ -1,6 +1,11 @@
 #include "pthread_impl.h"
 #include <threads.h>
 
+// XXX Emscripten implements pthread_create directly rather than __pthread_create
+#ifdef __EMSCRIPTEN__
+#define __pthread_create pthread_create
+#endif
+
 int __pthread_create(pthread_t *restrict, const pthread_attr_t *restrict, void *(*)(void *), void *restrict);
 
 int thrd_create(thrd_t *thr, thrd_start_t func, void *arg)
diff --git a/system/lib/libc/musl/src/thread/thrd_exit.c b/system/lib/libc/musl/src/thread/thrd_exit.c
index b66bd99695c..270d37045c2 100644
--- a/system/lib/libc/musl/src/thread/thrd_exit.c
+++ b/system/lib/libc/musl/src/thread/thrd_exit.c
@@ -1,6 +1,11 @@
 #include "pthread_impl.h"
 #include <threads.h>
 
+// XXX Emscripten implements pthread_exit directly rather than __pthread_exit
+#ifdef __EMSCRIPTEN__
+#define __pthread_exit pthread_exit
+#endif
+
 _Noreturn void __pthread_exit(void *);
 
 _Noreturn void thrd_exit(int result)
diff --git a/system/lib/libc/musl/src/thread/thrd_join.c b/system/lib/libc/musl/src/thread/thrd_join.c
index ac6678939f6..0149c89fb2b 100644
--- a/system/lib/libc/musl/src/thread/thrd_join.c
+++ b/system/lib/libc/musl/src/thread/thrd_join.c
@@ -1,6 +1,11 @@
 #include <stdint.h>
 #include <threads.h>
 
+// XXX Emscripten implements implements pthread_join directly rather than __pthread_join
+#ifdef __EMSCRIPTEN__
+#define __pthread_join pthread_join
+#endif
+
 int __pthread_join(thrd_t, void**);
 
 int thrd_join(thrd_t t, int *res)
diff --git a/system/lib/libc/musl/src/thread/thrd_sleep.c b/system/lib/libc/musl/src/thread/thrd_sleep.c
index e8dfe400cb7..37af3e21668 100644
--- a/system/lib/libc/musl/src/thread/thrd_sleep.c
+++ b/system/lib/libc/musl/src/thread/thrd_sleep.c
@@ -4,7 +4,11 @@
 
 int thrd_sleep(const struct timespec *req, struct timespec *rem)
 {
+#ifdef __EMSCRIPTEN__
+	int ret = nanosleep(req, rem);
+#else
 	int ret = __syscall(SYS_nanosleep, req, rem);
+#endif
 	switch (ret) {
 	case 0:      return 0;
 	case -EINTR: return -1; /* value specified by C11 */
diff --git a/system/lib/libc/musl/src/thread/thrd_yield.c b/system/lib/libc/musl/src/thread/thrd_yield.c
index f7ad13219ce..d30d8843ac1 100644
--- a/system/lib/libc/musl/src/thread/thrd_yield.c
+++ b/system/lib/libc/musl/src/thread/thrd_yield.c
@@ -3,5 +3,7 @@
 
 void thrd_yield()
 {
+#ifndef __EMSCRIPTEN__
 	__syscall(SYS_sched_yield);
+#endif
 }
diff --git a/tests/pthread/test_pthread_c11_threads.c b/tests/pthread/test_pthread_c11_threads.c
new file mode 100644
index 00000000000..7f8438749ae
--- /dev/null
+++ b/tests/pthread/test_pthread_c11_threads.c
@@ -0,0 +1,66 @@
+#include <stdio.h>
+#include <assert.h>
+#include <threads.h>
+
+once_flag flag = ONCE_FLAG_INIT;
+_Atomic int counter = 0;
+
+void do_once(void) {
+  counter++;
+  printf("in do_once\n");
+}
+
+int thread_main(void* arg) {
+  printf("in thread_main %p\n", thrd_current());
+  call_once(&flag, do_once);
+  printf("done thread_main\n");
+  return 42;
+}
+
+int run_with_exit() {
+  thrd_yield();
+  thrd_exit(43);
+}
+
+int main() {
+  int result = 0;
+  printf("thrd_current: %p\n", thrd_current());
+
+  // Test call_once
+  thrd_t t1;
+  thrd_t t2;
+  thrd_t t3;
+  thrd_t t4;
+
+  thrd_create(&t1, thread_main, NULL);
+  thrd_create(&t2, thread_main, NULL);
+  thrd_create(&t3, thread_main, NULL);
+  thrd_create(&t4, thread_main, NULL);
+
+  assert(!thrd_equal(t1, t2));
+  assert(thrd_equal(t1, t1));
+
+  thrd_join(t1, &result);
+  thrd_join(t2, &result);
+  thrd_join(t3, &result);
+  thrd_join(t4, &result);
+  assert(result == 42);
+  assert(counter == 1);
+
+  // Test thrd_exit return value
+  thrd_t t5;
+  thrd_create(&t5, run_with_exit, NULL);
+  thrd_join(t5, &result);
+  assert(result == 43);
+
+  // Test thrd_detach
+  thrd_t t6;
+  thrd_create(&t6, thread_main, NULL);
+  thrd_detach(t6);
+
+#ifdef REPORT_RESULT
+  REPORT_RESULT(0);
+#endif
+  printf("done!\n");
+  return 0;
+}
diff --git a/tests/pthread/test_pthread_c11_threads.out b/tests/pthread/test_pthread_c11_threads.out
new file mode 100644
index 00000000000..3b17e24adf2
--- /dev/null
+++ b/tests/pthread/test_pthread_c11_threads.out
@@ -0,0 +1 @@
+done!
diff --git a/tests/runner.py b/tests/runner.py
index dcadb768cb8..382070c4e75 100755
--- a/tests/runner.py
+++ b/tests/runner.py
@@ -525,8 +525,10 @@ def serialize_settings(self):
     for key, value in self.settings_mods.items():
       if value == 1:
         ret += ['-s', key]
+      elif type(value) == str:
+        ret += ['-s', f'{key}={value}']
       else:
-        ret += ['-s', '{}={}'.format(key, json.dumps(value))]
+        ret += ['-s', f'{key}={json.dumps(value)}']
     return ret
 
   def get_dir(self):
@@ -656,7 +658,7 @@ def run_js(self, filename, engine=None, args=[], output_nicerizer=None, assert_r
     stderr = self.in_dir('stderr')
     error = None
     if EMTEST_VERBOSE:
-      print(f"Running '{filename}' under '{engine}'")
+      print(f"Running '{filename}' under '{shared.shlex_join(engine)}'")
     try:
       jsrun.run_js(filename, engine, args,
                    stdout=open(stdout, 'w'),
diff --git a/tests/test_browser.py b/tests/test_browser.py
index e4c7f2d6eb3..06cc31f0d49 100644
--- a/tests/test_browser.py
+++ b/tests/test_browser.py
@@ -3562,6 +3562,13 @@ def prep_no_SAB(self):
       </script>
     '''))
 
+  @requires_threads
+  def test_pthread_c11_threads(self):
+    self.btest(path_from_root('tests', 'pthread', 'test_pthread_c11_threads.c'),
+               expected='0',
+               force_c=True,
+               args=['-g4', '-std=gnu11', '-xc', '-s', 'USE_PTHREADS', '-s', 'PROXY_TO_PTHREAD', '-s', 'TOTAL_MEMORY=64mb'])
+
   # Test that the emscripten_ atomics api functions work.
   @parameterized({
     'normal': ([],),
diff --git a/tests/test_core.py b/tests/test_core.py
index de9c154c8bb..3ac8cf79006 100644
--- a/tests/test_core.py
+++ b/tests/test_core.py
@@ -8063,6 +8063,13 @@ def test_fpic_static(self):
   def test_pthread_create(self):
     self.do_run_in_out_file_test('tests', 'core', 'pthread', 'create.cpp')
 
+  @node_pthreads
+  def test_pthread_c11_threads(self):
+    self.set_setting('PROXY_TO_PTHREAD')
+    self.set_setting('EXIT_RUNTIME')
+    self.set_setting('TOTAL_MEMORY', '64mb')
+    self.do_run_in_out_file_test('tests', 'pthread', 'test_pthread_c11_threads.c')
+
   @node_pthreads
   def test_pthread_create_pool(self):
     # with a pool, we can synchronously depend on workers being available
diff --git a/tools/system_libs.py b/tools/system_libs.py
index a6f60b14045..18e27fdd8d7 100755
--- a/tools/system_libs.py
+++ b/tools/system_libs.py
@@ -757,7 +757,16 @@ def get_files(self):
 
     libc_files += files_in_path(
         path_components=['system', 'lib', 'libc', 'musl', 'src', 'thread'],
-        filenames=['pthread_self.c'])
+        filenames=[
+          'pthread_self.c',
+          # C11 thread library functions
+          'thrd_create.c',
+          'thrd_exit.c',
+          'thrd_join.c',
+          'thrd_sleep.c',
+          'thrd_yield.c',
+          'call_once.c',
+        ])
 
     if self.is_mt:
       libc_files += files_in_path(
